# encoding: utf-8

module MyEpisodes
  class Dump
    def initialize(client, output, options={})
      @client = client
      @output = output
      @separator = options.fetch(:separator, ';')
    end

    def execute
      @output.puts(headers.join(@separator))
      @client.shows.each do |show|
        show.seasons.each do |season|
          season.episodes.each do |episode|
            @output.puts(to_line(show, season, episode).join(@separator))
          end
        end
      end
    end

    private

    def to_line(s, se, e)
      [s.name, se.name, e.number, e.name, e.acquired?, e.watched?]
    end

    def headers
      @headers ||= %w[show season number episode_name acquired watched].freeze
    end
  end
end
