# encoding: utf-8

module MyEpisodes
  class Show
    attr_reader :name

    def initialize(name)
      @name = name
      @seasons = []
    end

    def create(rows)
      season = nil
      rows.each do |row|
        if useless?(row)
          next
        elsif new_season?(row)
          @seasons << Season.new(self).create(row)
          season = @seasons.last
        else
          season << Episode.new(season).create(row.children)
        end
      end
      self
    end

    def seasons
      @seasons.freeze
    end

    private

    def useless?(row)
      row.text.strip.empty?
    end

    def new_season?(row)
      row.attr(CLASS) == HEADER
    end

    CLASS = 'class'.freeze
    HEADER = 'header'.freeze
  end
end
