# encoding: utf-8

module MyEpisodes
  class Shows
    include Enumerable

    def initialize(parser)
      @shows = []
      @parser = parser
    end

    def create(links)
      links.each do |link|
        name = link.text
        page = link.click
        rows = @parser.parse(page)
        @shows << Show.new(name).create(rows)
      end

      self
    end

    def each(&block)
      @shows.each(&block)
    end
  end
end
